part of tecfy_core_client_package;

abstract class IEntityAction {
  OperationResult<List<EAction>?> getActions(Map<String, dynamic>? data);
  OperationResult<List<EAction>?> getPageActions();
  bool hasAddPage() => false;
  bool hasEditPage(Map<String, dynamic>? data) => false;
  bool hasViewPage(Map<String, dynamic>? data) => false;
  Future addPage(BuildContext context) async => {};
  Future editPage(BuildContext context, Map<String, dynamic> data) async => {};
  Future viewPage(BuildContext context, Map<String, dynamic> data) async => {};
  Future<OperationResult> execAction(
      String name, Map<String, dynamic> data, BuildContext context);
}

class EAction {
  /// action code
  String dbName;

  /// action name arabic
  String nameAr;

  /// action english name
  String nameEn;

  /// action icon
  Widget icon;
  IconData iconData;
  EntityAction? serverSideAction;

  String get name => LocalConfigService.isArabic ? nameAr : nameEn;

  EAction(
      {required this.dbName,
      required this.nameAr,
      required this.nameEn,
      required this.icon,
      this.serverSideAction,
      required this.iconData});
}
