part of tecfy_core_client_package;

class CoreThemeService implements IThemeConfig {
  static IThemeConfig? old;

  static init() async {
    old = TecfyBasicApp.themeConfig;

    // // get the colors
    Map<String, dynamic> colors = ConfigService.getValueMap('appColors');
    print(colors);
    ColorModel colorModel = ColorModel.fromJson(colors);
    print(colorModel.secondColor);

    TecfyBasicApp.themeConfig = CoreThemeService(
      colorModel.secondColor != null
          ? Color(colorModel.secondColor!)
          : old?.secondColor,
      colorModel.subColor != null ? Color(colorModel.subColor!) : old?.subColor,
      colorModel.inactiveMenuTextColor != null
          ? Color(colorModel.inactiveMenuTextColor!)
          : old?.inactiveMenuTextColor,
      colorModel.subColorLight != null
          ? Color(colorModel.subColorLight!)
          : old?.subColorLight,
      colorModel.textSubColor != null
          ? Color(colorModel.textSubColor!)
          : old?.textSubColor,
      colorModel.textSelectedColor != null
          ? Color(colorModel.textSelectedColor!)
          : old?.textSelectedColor,
      colorModel.textMainColor != null
          ? Color(colorModel.textMainColor!)
          : old?.textMainColor,
      colorModel.mainColor2 != null
          ? Color(colorModel.mainColor2!)
          : old?.mainColor2,
      colorModel.backgroundSecondColor != null
          ? Color(colorModel.backgroundSecondColor!)
          : old?.backgroundSecondColor,
      colorModel.mainColor != null
          ? Color(colorModel.mainColor!)
          : old?.mainColor,
      colorModel.backgroundColor != null
          ? Color(colorModel.backgroundColor!)
          : old?.backgroundColor,
      colorModel.dangerColor != null
          ? Color(colorModel.dangerColor!)
          : old?.dangerColor,
      colorModel.successColor != null
          ? Color(colorModel.successColor!)
          : old?.successColor,
      colorModel.worningColor != null
          ? Color(colorModel.worningColor!)
          : old?.worningColor,
    );
  }

  CoreThemeService(
    this._secondColor,
    this._subColor,
    this._inactiveMenuTextColor,
    this._subColorLight,
    this._textSubColor,
    this._textSelectedColor,
    this._textMainColor,
    this._mainColor2,
    this._backgroundSecondColor,
    this._mainColor,
    this._backgroundColor,
    this._dangerColor,
    this._successColor,
    this._warningColor,
  );

  Color? _backgroundColor;

  @override
  Color get backgroundColor =>
      _backgroundColor ?? old?.backgroundColor ?? Colors.white;

  Color? _backgroundSecondColor;

  @override
  Color get backgroundSecondColor =>
      _backgroundSecondColor ?? old?.backgroundSecondColor ?? Colors.grey;
  Color? _dangerColor;

  @override
  Color get dangerColor => _dangerColor ?? old?.dangerColor ?? Colors.red;

  Color? _inactiveMenuTextColor;

  @override
  Color get inactiveMenuTextColor =>
      _inactiveMenuTextColor ?? old?.inactiveMenuTextColor ?? Colors.green;

  Color? _mainColor;

  @override
  Color get mainColor => _mainColor ?? old?.mainColor ?? Colors.orange;

  Color? _mainColor2;

  @override
  Color get mainColor2 => _mainColor2 ?? old?.mainColor2 ?? Colors.green;

  @override
  String? get mainFont => old?.mainFont ?? null;

  Color? _secondColor;

  @override
  Color get secondColor => _secondColor ?? old?.secondColor ?? Colors.blue;

  Color? _subColor;

  @override
  Color get subColor => _subColor ?? old?.subColor ?? Colors.grey;

  Color? _subColorLight;

  @override
  Color get subColorLight =>
      _subColorLight ?? old?.subColorLight ?? Colors.cyanAccent;
  Color? _successColor;

  @override
  Color get successColor => _successColor ?? old?.subColor ?? Colors.green;

  Color? _textMainColor;

  @override
  Color get textMainColor =>
      _textMainColor ?? old?.textMainColor ?? Colors.black;
  Color? _textSelectedColor;

  @override
  Color get textSelectedColor =>
      _textSelectedColor ?? old?.textSelectedColor ?? Colors.blue;
  Color? _textSubColor;

  @override
  Color get textSubColor =>
      _textSubColor ?? old?.textSubColor ?? Colors.deepPurple;

  Color? _warningColor;

  @override
  Color get worningColor => _warningColor ?? old?.worningColor ?? Colors.yellow;
}
