part of tecfy_core_client_package;

class LineChartSample1 extends StatefulWidget {
  /// chart type
  final DashboardChart type;

  /// dashboard charts
  LineChartSample1(this.type);
  @override
  State<StatefulWidget> createState() => _LineChartSample1State();
}

class _LineChartSample1State extends State<LineChartSample1> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return AspectRatio(
      aspectRatio: 1,
      child: Card(
          elevation: 1,
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.stretch,
            children: <Widget>[
              const SizedBox(height: 10),
              Row(
                crossAxisAlignment: CrossAxisAlignment.center,
                mainAxisSize: MainAxisSize.min,
                mainAxisAlignment: MainAxisAlignment.start,
                children: <Widget>[
                  const SizedBox(width: 10),
                  Icon(Icons.attach_money, color: Colors.black54),
                  const SizedBox(width: 20),
                  TecfyText(widget.type.title,
                      style: TextStyle(color: Colors.black38, fontSize: 20)),
                ],
              ),
              const SizedBox(height: 37),
              Row(
                mainAxisSize: MainAxisSize.max,
                mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                children: List.generate(
                    widget.type.properties.length,
                    (index) => _getIndicator(
                          text: LocalConfigService.isArabic
                              ? widget.type.labelsAr[index]
                              : widget.type.labelsEn[index],
                          color: Color(int.parse(
                                  widget.type.propertiesColor[index]
                                      .substring(1, 7),
                                  radix: 16) +
                              0xFF000000),
                          isSquare: false,
                          size: 10,
                          textColor: Colors.black54,
                        )),
              ),
              Expanded(
                child: Padding(
                  padding: const EdgeInsets.only(right: 16.0, left: 6.0),
                  child:
                      widget.type.value is List && widget.type.value.length >= 6
                          ? LineChart(
                              _getData(), //isShowingMainData ? sampleData1() : sampleData2(),
                              swapAnimationDuration:
                                  const Duration(milliseconds: 250),
                            )
                          : Center(
                              child: Container(
                                  child: TecfyText('Invalid '
                                      'Data'))),
                ),
              ),
              const SizedBox(height: 10),
            ],
          )),
    );
  }

  LineChartData _getData() {
    var maxVal = _getMax() * 1.2;
    return LineChartData(
      lineTouchData: LineTouchData(
        touchTooltipData: LineTouchTooltipData(
          tooltipBgColor: Colors.blueGrey.withOpacity(0.8),
        ),
        touchCallback: (t, LineTouchResponse? touchResponse) {},
        enabled: true,
        handleBuiltInTouches: true,
      ),
      gridData: FlGridData(show: false),
      titlesData: FlTitlesData(
          topTitles: AxisTitles(sideTitles: SideTitles(showTitles: false)),
          rightTitles: AxisTitles(sideTitles: SideTitles(showTitles: false)),
          bottomTitles: AxisTitles(
              sideTitles: SideTitles(
            showTitles: true,
            reservedSize: 22,
            // margin: 10,
            getTitlesWidget: (value, c) {
              if (value.floor() != value.ceil()) return TecfyText('');
              return TecfyText(widget.type.value[value.floor()]['key'] ?? '',
                  style: const TextStyle(
                    color: Color(0xff72719b),
                    fontWeight: FontWeight.bold,
                    fontSize: 16,
                  ));
            },
          )),
          leftTitles: AxisTitles(
            sideTitles: SideTitles(
              showTitles: true,

              getTitlesWidget: (value, c) {
                final style = TextStyle(
                  color: Color(0xff75729e),
                  fontWeight: FontWeight.bold,
                  fontSize: 14,
                );
                if (value > 1000000)
                  return TecfyText((value ~/ 1000000).toString() + 'M',
                      style: style);
                if (value > 1000)
                  return TecfyText((value ~/ 1000).toString() + 'K',
                      style: style);
                return TecfyText(value.toInt().toString(), style: style);
              },
              // margin: 8,
              reservedSize: 30,
              interval: (maxVal / 5) <= 0 ? 1 : (maxVal / 5),
            ),
          )),
      borderData: FlBorderData(
        show: true,
        border: const Border(
          bottom: BorderSide(color: Color(0xff4e4965), width: 4),
          left: BorderSide(color: Colors.transparent),
          right: BorderSide(color: Colors.transparent),
          top: BorderSide(color: Colors.transparent),
        ),
      ),
      minX: 0,
      maxX: ((widget.type.value?.length ?? 1) - 1.0).toDouble(),
      maxY: maxVal,
      minY: 0,
      lineBarsData: _getlinesBarData(),
    );
  }

  num _getMax() {
    if (widget.type.value == null || !(widget.type.value is List)) return 0;
    num v = 0;
    for (var itm in widget.type.value) {
      for (var key in widget.type.properties) if (v < itm[key]) v = itm[key];
    }
    return v;
  }

  // num _getMin(key) {
  //   if (widget.type.value == null || !(widget.type.value is List)) return 0;
  //   num? v;
  //   for (var itm in widget.type.value) {
  //     if (v == null) v = itm[key];
  //     if (v! > itm[key]) v = itm[key];
  //   }
  //   return v!;
  // }

  List<LineChartBarData> _getlinesBarData() {
    if (widget.type.value == null || !(widget.type.value is List)) return [];
    int index = -1;
    return widget.type.properties.map((p) {
      index++;
      var t = widget.type.value
          .map<FlSpot>((e) => FlSpot(
              widget.type.value
                  .indexWhere((i) => i['key'] == e['key'])
                  .toDouble(),
              e[p]))
          .toList();
      return LineChartBarData(
        spots: t,
        //curveSmoothness: 0.3,
        isCurved: true,
        //aboveBarData: BarAreaData(),
        color: widget.type.propertiesColor.length >= index
            ? new Color(int.parse(
                    widget.type.propertiesColor[index].substring(1, 7),
                    radix: 16) +
                0xFF000000)
            : const Color(0xff4af699),

        barWidth: 7,
        isStrokeCapRound: true,
        dotData: FlDotData(
          show: false,
        ),
        belowBarData: BarAreaData(
          show: false,
        ),
      );
    }).toList();
  }

  // LineChartData _sampleData1() {
  //   return LineChartData(
  //     lineTouchData: LineTouchData(
  //       touchTooltipData: LineTouchTooltipData(
  //         tooltipBgColor: Colors.blueGrey.withOpacity(0.8),
  //       ),
  //       touchCallback: (t, LineTouchResponse? touchResponse) {},
  //       handleBuiltInTouches: true,
  //     ),
  //     gridData: FlGridData(
  //       show: false,
  //     ),
  //     titlesData: FlTitlesData(
  //         bottomTitles: AxisTitles(
  //             sideTitles: SideTitles(
  //           showTitles: true,
  //           reservedSize: 22,

  //           // margin: 10,
  //           getTitlesWidget: (value) {
  //             switch (value.toInt()) {
  //               case 2:
  //                 return 'SEPT';
  //               case 7:
  //                 return 'OCT';
  //               case 12:
  //                 return 'DEC';
  //             }
  //             return '';

  //           },
  //         )),
  //         leftTitles: AxisTitles(
  //           sideTitles: SideTitles(
  //             showTitles: true,

  //             getTitlesWidget: (value, c) {
  //               String val = '';
  //               switch (value.toInt()) {
  //                 case 1:
  //                   val = '1m';
  //                   break;
  //                 case 2:
  //                   val = '2m';
  //                   break;
  //                 case 3:
  //                   val = '3m';
  //                   break;
  //                 case 4:
  //                   val = '5m';
  //                   break;
  //               }

  //               return TecfyText(
  //                 val,
  //                 style: TextStyle(
  //                   color: Color(0xff75729e),
  //                   fontWeight: FontWeight.bold,
  //                   fontSize: 14,
  //                 ),
  //               );
  //             },
  //             // margin: 8,
  //             reservedSize: 30,
  //           ),
  //         )),
  //     borderData: FlBorderData(
  //       show: true,
  //       border: const Border(
  //         bottom: BorderSide(
  //           color: Color(0xff4e4965),
  //           width: 4,
  //         ),
  //         left: BorderSide(
  //           color: Colors.transparent,
  //         ),
  //         right: BorderSide(
  //           color: Colors.transparent,
  //         ),
  //         top: BorderSide(
  //           color: Colors.transparent,
  //         ),
  //       ),
  //     ),
  //     minX: 0,
  //     maxX: 14,
  //     maxY: 4,
  //     minY: 0,
  //     lineBarsData: _linesBarData1(),
  //   );
  // }

  // List<LineChartBarData> _linesBarData1() {
  //   final LineChartBarData lineChartBarData1 = LineChartBarData(
  //     spots: [
  //       FlSpot(1, 1),
  //       FlSpot(3, 1.5),
  //       FlSpot(5, 1.4),
  //       FlSpot(7, 3.4),
  //       FlSpot(10, 2),
  //       FlSpot(12, 2.2),
  //       FlSpot(13, 1.8),
  //     ],
  //     isCurved: true,
  //     colors: [
  //       const Color(0xff4af699),
  //     ],
  //     barWidth: 8,
  //     isStrokeCapRound: true,
  //     dotData: FlDotData(
  //       show: false,
  //     ),
  //     belowBarData: BarAreaData(
  //       show: false,
  //     ),
  //   );
  //   final LineChartBarData lineChartBarData2 = LineChartBarData(
  //     spots: [
  //       FlSpot(1, 1),
  //       FlSpot(3, 2.8),
  //       FlSpot(7, 1.2),
  //       FlSpot(10, 2.8),
  //       FlSpot(12, 2.6),
  //       FlSpot(13, 3.9),
  //     ],
  //     isCurved: true,
  //     colors: [
  //       const Color(0xffaa4cfc),
  //     ],
  //     barWidth: 8,
  //     isStrokeCapRound: true,
  //     dotData: FlDotData(
  //       show: false,
  //     ),
  //     belowBarData: BarAreaData(show: false, colors: [
  //       const Color(0x00aa4cfc),
  //     ]),
  //   );
  //   final LineChartBarData lineChartBarData3 = LineChartBarData(
  //     spots: [
  //       FlSpot(1, 2.8),
  //       FlSpot(3, 1.9),
  //       FlSpot(6, 3),
  //       FlSpot(10, 1.3),
  //       FlSpot(13, 2.5),
  //     ],
  //     isCurved: true,
  //     colors: const [
  //       Color(0xff27b6fc),
  //     ],
  //     barWidth: 8,
  //     isStrokeCapRound: true,
  //     dotData: FlDotData(
  //       show: false,
  //     ),
  //     belowBarData: BarAreaData(
  //       show: false,
  //     ),
  //   );
  //   return [
  //     lineChartBarData1,
  //     lineChartBarData2,
  //     lineChartBarData3,
  //   ];
  // }

  // LineChartData _sampleData2() {
  //   return LineChartData(
  //     lineTouchData: LineTouchData(
  //       enabled: false,
  //     ),
  //     gridData: FlGridData(
  //       show: false,
  //     ),
  //     titlesData: FlTitlesData(
  //       bottomTitles: SideTitles(
  //         showTitles: true,
  //         reservedSize: 22,
  //         getTextStyles: (c, d) => TextStyle(
  //           color: Color(0xff72719b),
  //           fontWeight: FontWeight.bold,
  //           fontSize: 16,
  //         ),
  //         margin: 10,
  //         getTitles: (value) {
  //           switch (value.toInt()) {
  //             case 2:
  //               return 'SEPT';
  //             case 7:
  //               return 'OCT';
  //             case 12:
  //               return 'DEC';
  //           }
  //           return '';
  //         },
  //       ),
  //       leftTitles: SideTitles(
  //         showTitles: true,
  //         getTextStyles: (c, d) => TextStyle(
  //           color: Color(0xff75729e),
  //           fontWeight: FontWeight.bold,
  //           fontSize: 14,
  //         ),
  //         getTitles: (value) {
  //           switch (value.toInt()) {
  //             case 1:
  //               return '1m';
  //             case 2:
  //               return '2m';
  //             case 3:
  //               return '3m';
  //             case 4:
  //               return '5m';
  //             case 5:
  //               return '6m';
  //           }
  //           return '';
  //         },
  //         margin: 8,
  //         reservedSize: 30,
  //       ),
  //     ),
  //     borderData: FlBorderData(
  //         show: true,
  //         border: const Border(
  //           bottom: BorderSide(
  //             color: Color(0xff4e4965),
  //             width: 4,
  //           ),
  //           left: BorderSide(
  //             color: Colors.transparent,
  //           ),
  //           right: BorderSide(
  //             color: Colors.transparent,
  //           ),
  //           top: BorderSide(
  //             color: Colors.transparent,
  //           ),
  //         )),
  //     minX: 0,
  //     maxX: 14,
  //     maxY: 6,
  //     minY: 0,
  //     lineBarsData: _linesBarData2(),
  //   );
  // }

  // List<LineChartBarData> _linesBarData2() {
  //   return [
  //     LineChartBarData(
  //       spots: [
  //         FlSpot(1, 1),
  //         FlSpot(3, 4),
  //         FlSpot(5, 1.8),
  //         FlSpot(7, 5),
  //         FlSpot(10, 2),
  //         FlSpot(12, 2.2),
  //         FlSpot(13, 1.8),
  //       ],
  //       isCurved: true,
  //       curveSmoothness: 0,
  //       colors: const [
  //         Color(0x444af699),
  //       ],
  //       barWidth: 4,
  //       isStrokeCapRound: true,
  //       dotData: FlDotData(
  //         show: false,
  //       ),
  //       belowBarData: BarAreaData(
  //         show: false,
  //       ),
  //     ),
  //     LineChartBarData(
  //       spots: [
  //         FlSpot(1, 1),
  //         FlSpot(3, 2.8),
  //         FlSpot(7, 1.2),
  //         FlSpot(10, 2.8),
  //         FlSpot(12, 2.6),
  //         FlSpot(13, 3.9),
  //       ],
  //       isCurved: true,
  //       colors: const [
  //         Color(0x99aa4cfc),
  //       ],
  //       barWidth: 4,
  //       isStrokeCapRound: true,
  //       dotData: FlDotData(
  //         show: false,
  //       ),
  //       belowBarData: BarAreaData(show: true, colors: [
  //         const Color(0x33aa4cfc),
  //       ]),
  //     ),
  //     LineChartBarData(
  //       spots: [
  //         FlSpot(1, 3.8),
  //         FlSpot(3, 1.9),
  //         FlSpot(6, 5),
  //         FlSpot(10, 3.3),
  //         FlSpot(13, 4.5),
  //       ],
  //       isCurved: true,
  //       curveSmoothness: 0,
  //       colors: const [
  //         Color(0x4427b6fc),
  //       ],
  //       barWidth: 2,
  //       isStrokeCapRound: true,
  //       dotData: FlDotData(
  //         show: true,
  //       ),
  //       belowBarData: BarAreaData(
  //         show: false,
  //       ),
  //     ),
  //   ];
  // }

  _getIndicator(
      {required String text,
      required Color color,
      double size = 16,
      bool isSquare = false,
      Color? textColor}) {
    return Row(
      children: <Widget>[
        Container(
          width: size,
          height: size,
          decoration: BoxDecoration(
            shape: isSquare ? BoxShape.rectangle : BoxShape.circle,
            color: color,
          ),
        ),
        const SizedBox(
          width: 4,
        ),
        TecfyText(
          text,
          style: TextStyle(
              fontSize: 16,
              fontWeight: FontWeight.bold,
              color: textColor ?? color),
        )
      ],
    );
  }
}
