part of tecfy_core_client_package;

class LocationPropertyComponenet extends StatefulWidget {
  /// ini value
  final String? initalValue;

  /// label string
  final String? label;
  final String? description;

  /// is requried
  final bool isRequired;

  /// is read only
  final bool readOnly;

  /// on changed
  final void Function(String)? onChanged;
  LocationPropertyComponenet(
      {this.initalValue,
      this.label,
      this.description,
      this.isRequired = false,
      this.onChanged,
      this.readOnly = false});
  @override
  _LocationPropertyComponenetState createState() =>
      _LocationPropertyComponenetState();
}

class _LocationPropertyComponenetState
    extends State<LocationPropertyComponenet> {
  LatLng? _point;
  String? _currentValue;

  @override
  initState() {
    if (kDebugMode)
      print('------------------------------ ${widget.initalValue}');
    _currentValue = widget.initalValue;
    if (widget.initalValue == null || widget.initalValue!.isEmpty) {
      _point = null;
    } else {
      var p = widget.initalValue!.split(',');
      if (p.length >= 1) {
        _point = LatLng(double.parse(p[0]), double.parse(p[1]));
      }
    }
    if (_point == null) {
      // get my location
    }
    super.initState();
  }

  _onChanged() {
    var r = '${_point?.latitude ?? 0},${_point?.longitude ?? 0}';
    if (kDebugMode)
      print('----------------------------- Selected Location is $r');
    setState(() => _currentValue = r);
    widget.onChanged?.call(r);
  }

  @override
  Widget build(BuildContext context) {
    return MaterialButton(
        padding: EdgeInsets.all(0),
        onPressed: () async {
          var result = await showDialog(
              context: context, builder: (c) => LocationSelectPage(_point!));
          if (result != null) {
            _point = result;
            _onChanged();
          }
        },
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: <Widget>[
            SizedBox(height: 10),
            Tooltip(
                message: widget.description ?? '',
                child: TecfyText(
                  '${widget.label ?? ''}${widget.isRequired ? '*' : ''}',
                  style: ThemeService.labelStyle,
                )),
            TecfyText(_currentValue == null || _currentValue!.isEmpty
                ? '[Click To Select]'
                : _currentValue!),
            SizedBox(height: 10),
            Container(height: 1, color: ThemeService.textSubColor)
          ],
        ));
  }
}

class LocationSelectPage extends StatefulWidget {
  final LatLng location;
  LocationSelectPage(this.location);
  @override
  _LocationSelectPageState createState() => _LocationSelectPageState();
}

class _LocationSelectPageState extends State<LocationSelectPage> {
  // String _mapStyle;
  LatLng? _point;
  GlobalKey _key = GlobalKey();
  // GoogleMapController _controller;
  @override
  initState() {
    _point = widget.location;
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        width: MediaQuery.of(context).size.width,
        height: MediaQuery.of(context).size.height,
        child: Column(
          children: [
            Expanded(
                flex: 10,
                child: GoogleMap(
                  zoomControlsEnabled: true,
                  // onMapCreated: (c) => _controller = c,
                  key: _key,
                  initialCameraPosition: CameraPosition(
                      zoom: 10,
                      target: _point == null
                          ? LatLng(31.274750, 32.301204)
                          : _point!),
                  // initialPosition: point ?? GeoCoord(0, 0),
                  mapType: MapType.hybrid,
                  indoorViewEnabled: true,
                  myLocationButtonEnabled: true,
                  myLocationEnabled: true,
                  markers: _point == null
                      ? {}
                      : {
                          Marker(
                              position: _point!,
                              markerId: MarkerId("marker2"),
                              icon: BitmapDescriptor.defaultMarker)
                        },

                  onTap: (coord) {
                    setState(() {
                      _point = coord;
                    });
                    // _controller.getLatLng(screenCoordinate)
                    // GoogleMap.of(_key).clearMarkers();
                    // GoogleMap.of(_key).addMarker(Marker(point));
                  },
                )),
            Expanded(
                flex: 1,
                child: Container(
                    color: Colors.white,
                    child: Row(children: [
                      TextButton(
                          child: TecfyText('OK'),
                          onPressed: () {
                            Navigator.pop(context, _point);
                          }),
                      TextButton(
                          child: TecfyText('Cancel'),
                          onPressed: () {
                            Navigator.pop(context);
                          }),
                    ])))
          ],
        ));
  }
}
