part of tecfy_core_client_package;

abstract class PropertyBase extends StatefulWidget {
  /// the property object
  final Property property;

  /// the main entity
  final Entity? entity;

  /// change the value style
  final TextStyle? valueStyle;

  /// if we don't need to show label
  final bool noLabel;

  /// is add new so we can show or hide according to property config
  final bool isAddNew;

  /// on change
  final void Function(dynamic)? onChange;

  /// on submit
  final void Function(dynamic)? onSubmit;

  /// on update
  final void Function(Map<String, dynamic>)? onUpdateData;
  //final dynamic initalValue;
  /// if this property is a dropdown and it's filterd by another field
  //final dynamic filterValue;
  final Map<String, dynamic> data;

  /// show all property as read only
  final bool readOnly;

  ///isFoucsed
  //final bool isFoucs;

  /// on open Popup
  final void Function()? onOpen;

  /// on close popup
  final void Function()? onClose;

  PropertyBase({
    Key? key,
    required this.property,
    this.entity,
    this.onChange,
    this.onSubmit,
    this.isAddNew = false,
    this.onUpdateData,
    this.valueStyle,
    this.noLabel = false,
    //this.filterValue,
    required this.data,
    this.readOnly = false,
    this.onOpen,
    this.onClose,
  }) : super(key: key);
}
