part of tecfy_core_client_package;

class EntityListBasePage extends StatefulWidget {
  final List<Property> properties;
  final List<Map<String, dynamic>> data;
  final String title;
  final FutureOr Function() onAdd;
  final FutureOr Function() onRefresh;
  final FutureOr Function(Map<String, dynamic>) onEdit;
  final FutureOr Function(Map<String, dynamic>) onDelete;
  EntityListBasePage(
      {required this.properties,
      required this.data,
      required this.title,
      required this.onAdd,
      required this.onDelete,
      required this.onRefresh,
      required this.onEdit});
  @override
  _EntityListBasePageState createState() => _EntityListBasePageState();
}

class _EntityListBasePageState extends TecfyAppState<EntityListBasePage> {
  late ScrollController scrollController;
  late List<Map<String, dynamic>> filterdData;
  late TextEditingController searchController;
  RefreshController refreshController =
      RefreshController(initialRefresh: false); // for pull to refrsh

  bool? _isTree = false;
  bool get isTree {
    if (_isTree == null && widget.properties != null)
      _isTree = widget.properties.any((d) => d.dbName == 'parentId');
    return _isTree ?? false;
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(context, widget.title, '',
        isMobile: LayoutService.isMobile(context),
        floatingActionButtonWidget:
            LayoutService.isMobile(context) && widget.onAdd != null
                ? FloatingActionButton(
                    backgroundColor: ThemeService.mainColor,
                    onPressed: widget.onAdd,
                    child: Icon(Icons.add))
                : null,
        child: widget.data == null
            ? Center(child: AppNavigator.getLoadingWidget(100))
            : LayoutService.bindWidget(
                context,
                // mobileWidget: _getMobileWidget(),
                // tabletWidget: _getTabletWidget(),
                // descktopWidget: _getDesktopWidget(),
              ));
  }

  // Map<int, TableColumnWidth> getColumnWidths() {
  //   var columns = widget.properties
  //       .where((e) =>
  //           e.isGrid &&
  //           (e.language == Language.notSelected ||
  //               e.language == LocalConfigService.language))
  //       .toList();

  //   Map<int, TableColumnWidth> data = {};
  //   int testCount = 0;

  //   if (isTree) data[0] = FixedColumnWidth(60);

  //   for (int i = 0; i < columns.length; i++) {
  //     switch (columns[i].propertyType) {
  //       case PropertyTypes.TecfyText:
  //         data[isTree ? 1 + i : i] = FlexColumnWidth(testCount == 1 ? 2 : 1);
  //         testCount++;
  //         break;
  //       case PropertyTypes.File:
  //         data[isTree ? 1 + i : i] = FixedColumnWidth(60);
  //         break;
  //       case PropertyTypes.Number:
  //         data[isTree ? 1 + i : i] = FlexColumnWidth(0.5);
  //         break;
  //       case PropertyTypes.Boolean:
  //         data[isTree ? 1 + i : i] = FixedColumnWidth(40);
  //         break;
  //       default:
  //         data[isTree ? 1 + i : i] = FlexColumnWidth(1);
  //         break;
  //     }
  //   }

  //   data[isTree ? 1 + columns.length : columns.length] = FixedColumnWidth(40);
  //   data[isTree ? 2 + columns.length : 1 + columns.length] =
  //       FixedColumnWidth(40);
  //   // if (_controller.hasActions(null)) {
  //   //   data[isTree ? 3 + columns.length : 2 + columns.length] =
  //   //       FixedColumnWidth((_controller.getActions(null)?.length ?? 0) * 40.0);
  //   // }
  //   return data;
  // }

  // Widget _getDesktopWidget() {
  //   return Column(
  //     crossAxisAlignment: CrossAxisAlignment.stretch,
  //     children: <Widget>[
  //       Row(children: <Widget>[
  //         Expanded(
  //             child: SearchBox(
  //                 searchTextController: searchController,
  //                 placeholder: trans('Search'),
  //                 onChange: (v) => _controller.globalSearchText(),
  //                 onSubmit: (v) => _controller.globalSearchTextServer())),
  //         SizedBox(width: 10),
  //         widget.onAdd != null
  //             ? AppButtonIconText(
  //                 onPressed: widget.onAdd,
  //                 label: trans('Add'),
  //                 height: 35,
  //                 icon: Icon(Icons.add, color: ThemeService.textOnMainColor),
  //                 color: ThemeService.secondryColor)
  //             : Container(),
  //         SizedBox(width: 10),
  //         AppButtonIconText(
  //             onPressed: widget.onRefresh,
  //             label: trans('Refresh'),
  //             height: 35,
  //             icon: Icon(Icons.refresh, color: ThemeService.textOnMainColor),
  //             color: ThemeService.subColor),
  //         SizedBox(width: 10),
  //       ]),
  //       Expanded(
  //           child: Scrollbar(
  //               isAlwaysShown: true,
  //               showTrackOnHover: true,
  //               controller: scrollController,
  //               child: SingleChildScrollView(
  //                 controller: scrollController,
  //                 child: Container(
  //                     margin: EdgeInsets.symmetric(horizontal: 30, vertical: 5),
  //                     child: AnimationLimiter(
  //                       //key:UniqueKey(),
  //                       child: Table(
  //                         columnWidths: getColumnWidths(),
  //                         children: _getTableRows(),
  //                       ),
  //                     )),
  //               ))),
  //       _controller.hasPageing
  //           ? SizedBox(
  //               height: 50,
  //               child: Row(
  //                 children: [
  //                   Expanded(
  //                     child: ListView.builder(
  //                       itemCount: (_controller.pageIndexMax + 2),
  //                       scrollDirection: Axis.horizontal,
  //                       itemBuilder: (_context, pageIndex) => pageIndex ==
  //                               _controller.pageIndexMax + 1
  //                           ? (_controller.hasNextPage
  //                               ? TextButton(
  //                                   child: TecfyText(AppLocale.translate(
  //                                       context, 'Next Page')),
  //                                   onPressed: _controller.gotoMextPageIndex)
  //                               : Container())
  //                           : IconButton(
  //                               padding: EdgeInsets.all(0),
  //                               icon: TecfyText(
  //                                 (pageIndex + 1).toString(),
  //                                 style: TextStyle(
  //                                     color: pageIndex == _controller.pageIndex
  //                                         ? ThemeService.mainColor
  //                                         : ThemeService.secondryColor),
  //                               ),
  //                               onPressed: () =>
  //                                   _controller.gotoPageIndex(pageIndex),
  //                             ),
  //                     ),
  //                   )
  //                 ],
  //               ),
  //             )
  //           : Container()
  //     ],
  //   );
  // }

  // Widget _getTabletWidget() {
  //   return Column(
  //     crossAxisAlignment: CrossAxisAlignment.stretch,
  //     children: <Widget>[
  //       Row(children: <Widget>[
  //         Expanded(
  //             child: SearchBox(
  //                 searchTextController: searchController,
  //                 placeholder: trans('Search'),
  //                 onChange: (v) => _controller.globalSearchText())),
  //         widget.onAdd != null
  //             ? AppButtonIconText(
  //                 onPressed: widget.onAdd,
  //                 label: trans('Add'),
  //                 height: 35,
  //                 icon: Icon(Icons.add, color: ThemeService.textOnMainColor),
  //                 color: ThemeService.secondryColor)
  //             : Container(),
  //         SizedBox(width: 10),
  //         AppButtonIconText(
  //             onPressed: widget.onRefresh,
  //             label: trans('Refresh'),
  //             height: 35,
  //             icon: Icon(Icons.refresh, color: ThemeService.textOnMainColor),
  //             color: ThemeService.subColor),
  //         SizedBox(width: 10),
  //       ]),
  //       Expanded(
  //         child: Scrollbar(
  //           isAlwaysShown: true,
  //           showTrackOnHover: true,
  //           controller: scrollController,
  //           child: SingleChildScrollView(
  //             controller: scrollController,
  //             child: Container(
  //                 margin: EdgeInsets.symmetric(horizontal: 30, vertical: 5),
  //                 child: AnimationLimiter(
  //                   //key:UniqueKey(),
  //                   child: Table(
  //                     columnWidths: getColumnWidths(),
  //                     children: _getTableRows(),
  //                   ),
  //                 )),
  //           ),
  //         ),
  //       ),
  //       _controller.hasPageing
  //           ? SizedBox(
  //               height: 50,
  //               child: ListView.builder(
  //                 itemCount: (_controller.pageIndexMax + 2),
  //                 scrollDirection: Axis.horizontal,
  //                 itemBuilder: (_context, pageIndex) => pageIndex ==
  //                         _controller.pageIndexMax + 1
  //                     ? (_controller.hasNextPage
  //                         ? FlatButton(
  //                             child: TecfyText(
  //                                 AppLocale.translate(context, 'Next Page')),
  //                             onPressed: _controller.gotoMextPageIndex)
  //                         : Container())
  //                     : IconButton(
  //                         padding: EdgeInsets.all(0),
  //                         icon: TecfyText(
  //                           (pageIndex + 1).toString(),
  //                           style: TextStyle(
  //                               color: pageIndex == _controller.pageIndex
  //                                   ? ThemeService.mainColor
  //                                   : ThemeService.secondryColor),
  //                         ),
  //                         onPressed: () => _controller.gotoPageIndex(pageIndex),
  //                       ),
  //               ),
  //             )
  //           : Container()
  //     ],
  //   );
  // }

  // addChildren(items, List<TableRow> rows) {
  //   for (var item in items) {
  //     rows.add(_getTableRow(item, rowIndex++));
  //     // if (item['_expanded'] == true &&
  //     //     item['_children'] != null &&
  //     //     item['_children'].length > 0) {
  //     //   rows = addChildren(item['_children'], rows);
  //     // }
  //   }
  //   return rows;
  // }

  // int rowIndex = 0;
  // List<TableRow> _getTableRows() {
  //   List<TableRow> rows = [];
  //   rows.add(_getHeaderRow());
  //   rowIndex = 1;
  //   return addChildren(filterdData, rows);
  // }

  // TableRow _getTableRow(d, rowIndex) {
  //   var props = widget.properties
  //       .where((e) =>
  //           e.isGrid &&
  //           (e.language == Language.notSelected ||
  //               e.language == LocalConfigService.language))
  //       .map<Widget>((p) => _getCell(p, d))
  //       .toList()
  //         ..add(_editCell(d));

  //   if (widget.onDelete != null) props.add(_deleteCell(d));

  //   if (isTree) props.insert(0, _treeCell(d));

  //   // if (_controller.hasActions(null)) {
  //   //   if (_controller.hasActions(d)) {
  //   //     props.add(Row(
  //   //         children: _controller
  //   //             .getActions(d)
  //   //             .map((action) => IconButton(
  //   //                   icon: action.icon ?? Icon(Icons.local_activity_outlined),
  //   //                   tooltip: action.nameAr,
  //   //                   onPressed: () => _controller.onAction(action, d),
  //   //                 ))
  //   //             .toList()));
  //   //   } else {
  //   //     props.add(Container());
  //   //   }
  //   // }

  //   return TableRow(
  //     decoration: BoxDecoration(
  //         color: rowIndex % 2 == 0
  //             ? ThemeService.backgroundSecondColor
  //             : ThemeService.backgroundColor),
  //     children: AnimationConfiguration.toStaggeredList(
  //       duration: const Duration(milliseconds: 375),
  //       childAnimationBuilder: (widget) => SlideAnimation(
  //           horizontalOffset: 50.0,
  //           child: SlideAnimation(
  //             verticalOffset: 50.0,
  //             child: FadeInAnimation(
  //               child: widget,
  //             ),
  //           )),
  //       children: props,
  //     ),
  //   );
  // }

  // TableRow _getHeaderRow() {
  //   var props = widget.properties
  //       .where((e) =>
  //           e.isGrid &&
  //           (e.language == Language.notSelected ||
  //               e.language == LocalConfigService.language))
  //       .map<TableCell>((p) => _getHeader(p))
  //       .toList()
  //         ..add(_getHeaderCell(
  //             widget.onEdit != null ? trans('Edit') : trans('Details'),
  //             false,
  //             null,
  //             true));

  //   if (widget.onDelete != null)
  //     props.add(_getHeaderCell(
  //         AppLocale.translate(context, 'Delete'), false, null, true));
  //   // if (_controller.hasActions(null))
  //   //   props.add(_getHeaderCell(
  //   //       AppLocale.translate(context, 'Action'), false, null, true));
  //   if (isTree) props.insert(0, _getHeaderCell('--', false, null, true));
  //   return TableRow(children: props);
  // }

  // Widget _editCell(Map<String, dynamic> data) {
  //   return IconButton(
  //     tooltip: widget.onEdit != null ? trans('Edit') : trans('Details'),
  //     padding: EdgeInsets.all(0),
  //     icon: Icon(Icons.note, color: ThemeService.mainColor),
  //     onPressed: () => widget.onEdit(data),
  //   );
  // }

  // Widget _treeCell(Map<String, dynamic> data) {
  //   if (data['_children'] != null && data['_children'].length == 0)
  //     return Container();
  //   return IconButton(
  //     tooltip: trans(data['_expanded'] == true ? 'Collapse' : 'Expand'),
  //     padding: EdgeInsets.only(
  //         right: LocalConfigService.isArabic
  //             ? ((data['_tree_level'] as num) ?? 0).toDouble() * 10.0
  //             : 0.0,
  //         left: LocalConfigService.isArabic
  //             ? 0.0
  //             : ((data['_tree_level'] ?? 0) as num).toDouble() * 10.0),
  //     icon: Icon(data['_expanded'] == true ? Icons.remove : Icons.add,
  //         color: ThemeService.mainColor, size: 15),
  //     //onPressed: () => _controller.expandItem(data),
  //   );
  // }

  // Widget _deleteCell(Map<String, dynamic> data) {
  //   return data['isLocked'] == true || widget.onDelete == null
  //       ? Container()
  //       : IconButton(
  //           tooltip: trans('Delete'),
  //           padding: EdgeInsets.all(0),
  //           icon: Icon(Icons.delete, color: ThemeService.dangerColor),
  //           onPressed: () => widget.onDelete(data),
  //         );
  // }

  // TableCell _getHeader(Property prop) {
  //   return _getHeaderCell(
  //       prop.name, prop.dbName == sortProp, () => sortBy(prop));
  // }

  // TableCell _getHeaderCell(String text,
  //     [bool isSelected = false, onPressed, bool isCenter = false]) {
  //   return TableCell(
  //       child: MaterialButton(
  //           padding: EdgeInsets.all(0),
  //           child: Align(
  //               alignment: isCenter
  //                   ? Alignment.center
  //                   : LocalConfigService.isArabic
  //                       ? Alignment.centerRight
  //                       : Alignment.centerLeft,
  //               child: TecfyText('$text ${isSelected ? '*' : ''}',
  //                   textAlign: TextAlign.start,
  //                   style: TextStyle(
  //                       fontSize: 12,
  //                       fontWeight:
  //                           isSelected ? FontWeight.bold : FontWeight.normal,
  //                       color: ThemeService.secondryColor
  //                       //color: isSelected ? ThemeService.mainColor : ThemeService.secondryColor
  //                       ))),
  //           onPressed: onPressed));
  // }

  // Widget _getCell(Property prop, data, {totals: false}) {
  //   if (prop.isImage) {
  //     if (data[prop.dbName + 'Id'] == null ||
  //         data[prop.dbName + 'Id'].toString().isEmpty) {
  //       return Container();
  //     }
  //     return Align(
  //         alignment: LocalConfigService.isArabic
  //             ? Alignment.centerRight
  //             : Alignment.centerLeft,
  //         child: Image(
  //             image: ImageService.imageProvider(data[prop.dbName + 'Id']),
  //             height: 50));
  //   }

  //   var val = data[prop.dbName];
  //   if (totals) {
  //     if (val == null || val == 0 || val == '' || val == '0') {
  //       return Container();
  //     }
  //   } else {
  //     if (val == null) {
  //       return Container();
  //     }
  //   }

  //   Widget widgetValue = Padding(
  //     padding: EdgeInsets.only(
  //         top: prop.valueType == ValueTypes.Boolean ? 7 : 0, right: 2, left: 2),
  //     child: Align(
  //       alignment: LocalConfigService.isArabic
  //           ? Alignment.centerRight
  //           : Alignment.centerLeft,
  //       child: prop.getDisplayWidget(data),
  //     ),
  //   );
  //   return Padding(
  //       padding: EdgeInsets.only(
  //           top: 10.0,
  //           right: LocalConfigService.isArabic
  //               ? (((data['_tree_level'] ?? 0) as num).toDouble()) * 10.0
  //               : 0.0,
  //           left: LocalConfigService.isArabic
  //               ? 0.0
  //               : (((data['_tree_level'] ?? 0) as num).toDouble()) * 10.0),
  //       child: widgetValue);
  // }

  // Widget _getMobileWidget() {
  //   return Column(children: [
  //     Padding(
  //         padding: EdgeInsets.only(right: 10),
  //         child: SearchBox(
  //             searchTextController: searchController,
  //             placeholder: trans('Search'),
  //             onChange: (v) => _controller.globalSearchText())),
  //     SizedBox(height: 20),
  //     Expanded(
  //         child: AnimationLimiter(
  //             child: SmartRefresher(
  //                 enablePullDown: true,
  //                 enablePullUp: true,
  //                 onRefresh: _controller.loadFromServer,
  //                 controller: refreshController,
  //                 header: WaterDropHeader(complete: Icon(Icons.done)),
  //                 footer: CustomFooter(
  //                   builder: (BuildContext context, LoadStatus mode) {
  //                     Widget body;
  //                     if (mode == LoadStatus.idle) {
  //                       body = TecfyText("pull up load");
  //                     } else if (mode == LoadStatus.loading) {
  //                       body = CupertinoActivityIndicator();
  //                     } else if (mode == LoadStatus.failed) {
  //                       body = TecfyText("Load Failed!Click retry!");
  //                     } else if (mode == LoadStatus.canLoading) {
  //                       body = TecfyText("release to load more");
  //                     } else {
  //                       body = TecfyText("No more Data");
  //                     }
  //                     return Container(
  //                       height: 55.0,
  //                       child: Center(child: body),
  //                     );
  //                   },
  //                 ),
  //                 child: ListView.builder(
  //                     itemCount: filterdData.length,
  //                     itemBuilder: (BuildContext context, int index) {
  //                       return AnimationConfiguration.staggeredList(
  //                         position: index,
  //                         duration: const Duration(milliseconds: 375),
  //                         child: SlideAnimation(
  //                           verticalOffset: 50.0,
  //                           horizontalOffset: 50.5,
  //                           child: FlipAnimation(
  //                             flipAxis: FlipAxis.y,
  //                             child: _getMobileRow(filterdData[index]),
  //                           ),
  //                         ),
  //                       );
  //                     }))
  //             // ListView(
  //             //     // controller: _controller.scrollController,
  //             //     children:
  //             //         _controller.data.map<Widget>((d) => _getMobileRow(d)).toList()
  //             //     //..add(_controller.hasNextPage ? FlatButton
//             (child:TecfyText('Load More'),onPressed: _controller
//             .gotoMextPageIndex) : Container())
  //             //     ),
  //             ))
  //   ]);
  // }

  // Widget _getMobileRow(d) {
  //   return Slidable(
  //     // delegate: SlidableDrawerDelegate(),
  //     actionPane: SlidableDrawerActionPane(),
  //     actionExtentRatio: 0.25,
  //     child: Container(
  //         child: EntityListTileComponent(_controller.entity, d,
  //             onClick: (_d) => widget.onEdit(_d),
  //             onExpandItem: (_d) => expandItem(_d))),

  //     actions:
  //         // _controller
  //         //         .getActions(d)
  //         //         ?.map(
  //         //           (a) => IconSlideAction(
  //         //               caption: a.nameAr,
  //         //               color: ThemeService.mainColor,
  //         //               icon: a.iconData,
  //         //               onTap: () => _controller.onAction(a, d)),
  //         //         )
  //         //         ?.toList() ??
  //         [],
  //     secondaryActions: widget.onDelete == null
  //         ? []
  //         : <Widget>[
  //             // IconSlideAction(
  //             //   caption: 'More',
  //             //   color: Colors.black45,
  //             //   icon: Icons.more_horiz,
  //             //   onTap: () => _showSnackBar('More'),
  //             // ),
  //             IconSlideAction(
  //               caption: AppLocale.translate(context, 'Delete'),
  //               color: Colors.red,
  //               icon: Icons.delete,
  //               onTap: () => widget.onDelete(d),
  //             ),
  //           ],
  //   );
  // }
}
