part of tecfy_core_client_package;

// active menu
class MainDrawer2 extends StatefulWidget {
  final dynamic selected;
  MainDrawer2(this.selected);
  @override
  _MainDrawer2State createState() => _MainDrawer2State();
}

class _MainDrawer2State extends TecfyAppState<MainDrawer2> {
  // static double _posstion = 0;
  bool _isMobile = true;
  double _topMargen = 0;
  late ScrollController _controller;
  String? _beforeSelectedCategory;
  String? _afterSelectedCategory;
  String? _selectedCategory;
  bool isArabic = false;

  @override
  void initState() {
    isArabic = LocalConfigService.isArabic;
    _controller = ScrollController();

    // get category based on selected item
    if (InitService.menuItems != null && InitService.menuItems!.length > 0) {
      var selected = InitService.menuItems!.where((e) =>
          e.title == widget.selected ||
          (e.subMenuItems?.any((s) => s.title == widget.selected) ?? false));
      if (selected.length > 0) {
        _updatedSelected(selected.first.title);
      }
    }

    //_selectedCategory = widget.selected;

    // Future.delayed(Duration(milliseconds: 100)).then((_) {
    //   if (_controller.offset != _posstion) _controller.jumpTo(_posstion);
    //   _controller.addListener(() {
    //     _posstion = _controller.offset ?? 0;
    //   });
    // });
    super.initState();
  }

  _updatedSelected(String? category) {
    _selectedCategory = category;
    if (InitService.menuItems != null &&
        InitService.menuItems!.length > 0 &&
        _selectedCategory != null &&
        _selectedCategory!.isNotEmpty &&
        InitService.menuItems!.any((e) => e.title == category)) {
      var index = InitService.menuItems!.indexWhere((e) => e.title == category);

      if (index == 0) {
        _beforeSelectedCategory = null;
      } else {
        _beforeSelectedCategory = InitService.menuItems![index - 1].title;
      }

      if (index == InitService.menuItems!.length - 1) {
        _afterSelectedCategory = null;
      } else {
        _afterSelectedCategory = InitService.menuItems![index + 1].title;
      }
    } else {
      _afterSelectedCategory = null;
      _beforeSelectedCategory = null;
      _selectedCategory = null;
    }
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  _onItemClick(TecfyMenuItem itm) {
    if (itm.subMenuItems != null && itm.subMenuItems!.length > 0) {
      setState(() {
        if (itm.title == _selectedCategory) {
          _updatedSelected(null);
        } else {
          _updatedSelected(itm.title);
        }
      });
    }
    // if (itm.title != widget.selected) {
    // }

    itm.onClick?.call(context);
  }

  @override
  Widget build(BuildContext context) {
    _isMobile = LayoutService.isMobile(context);
    //_topMargen = _isMobile ? 30 : 0;
    _topMargen = MediaQuery.of(context).padding.top;
    return Drawer(
      child: Container(
          color: ThemeService.mainColor,
          child: Column(
            children: <Widget>[
              Container(
                child: Stack(
                  children: <Widget>[
                    Container(
                      height: 120 + _topMargen,
                      decoration: BoxDecoration(
                        borderRadius: BorderRadius.only(
                          bottomLeft: LocalConfigService.isArabic
                              ? Radius.circular(50)
                              : Radius.circular(0),
                          bottomRight: LocalConfigService.isArabic
                              ? Radius.circular(0)
                              : Radius.circular(50),
                        ),
                        color: ThemeService.secondryColor,
                      ),
                      child: !_isMobile
                          ? Align(
                              alignment: Alignment.bottomRight,
                              child: Padding(
                                  padding: EdgeInsets.only(
                                      right: 95, left: 0, bottom: 6),
                                  child: TextButton(
                                      //hoverColor: Colors.transparent,
                                      style: ButtonStyle(
                                          overlayColor:
                                              MaterialStateProperty.all(
                                                  Colors.transparent),
                                          shadowColor:
                                              MaterialStateProperty.all(
                                                  Colors.transparent)),
                                      // splashColor: Colors.transparent,
                                      // focusColor: Colors.transparent,
                                      // highlightColor: Colors.transparent,
                                      child: TecfyText(trans('Main Page'),
                                          style: TextStyle(
                                              fontSize: 18,
                                              color: ThemeService
                                                  .textOnSecondColor)),
                                      onPressed: () => AppNavigator.navigateTo(
                                          context, () => DashboardPage(),
                                          replaceAll: true))))
                          : Align(
                              alignment: Alignment.bottomCenter,
                              child: Padding(
                                padding: EdgeInsets.only(
                                    right: LocalConfigService.isArabic ? 95 : 0,
                                    left: LocalConfigService.isArabic ? 0 : 95,
                                    bottom: 18),
                                child: Row(
                                  children: <Widget>[
                                    TecfyText(trans('Welcome'),
                                        style: TextStyle(
                                            color: ThemeService
                                                .textOnSecondColor)),
                                    TecfyText(',',
                                        style: TextStyle(
                                            color: ThemeService
                                                .textOnSecondColor)),
                                    Expanded(
                                      child: TecfyText(
                                        LocalConfigService.user?.fullName ??
                                            trans("Guest"),
                                        textDirection: TextDirection.rtl,
                                        maxLines: 1,
                                        overflow: TextOverflow.fade,
                                        style: TextStyle(
                                            color:
                                                ThemeService.textOnSecondColor,
                                            fontSize: 18),
                                      ),
                                    )
                                  ],
                                ),
                              ),
                            ),
                    ),
                    Container(
                        height: 60 + _topMargen,
                        decoration: BoxDecoration(
                          borderRadius: BorderRadius.only(
                            bottomLeft: LocalConfigService.isArabic
                                ? Radius.circular(50)
                                : Radius.circular(0),
                            bottomRight: LocalConfigService.isArabic
                                ? Radius.circular(0)
                                : Radius.circular(50),
                          ),
                          color: ThemeService.backgroundColor,
                        ),
                        child: !_isMobile
                            ? null
                            : Align(
                                alignment: Alignment.bottomCenter,
                                child: Row(
                                  mainAxisAlignment: MainAxisAlignment.end,
                                  children: <Widget>[
                                    SizedBox(width: 30),
                                    IconButton(
                                        tooltip: trans('Chat'),
                                        onPressed: () =>
                                            AppNavigator.navigateTo(context,
                                                () => ChatContactsPage()),
                                        icon: Icon(Icons.markunread,
                                            color: ThemeService.textSubColor)),
                                    SizedBox(width: 2),
                                    NotificationIcon(
                                        color: ThemeService.textSubColor),
                                    SizedBox(width: 2),
                                    SettingIcon(
                                        color: ThemeService.textSubColor),
                                    SizedBox(width: 30),
                                  ],
                                ))),
                    Padding(
                        padding: EdgeInsets.only(
                            right: 10, left: 10, top: 10 + _topMargen),
                        child: Container(
                            child:
                                LocalConfigService.company['logoId'] != null &&
                                        LocalConfigService.company['logoId']
                                            .toString()
                                            .isNotEmpty
                                    ? ImageService.image(
                                        LocalConfigService.company['logoId'],
                                        radius: 40)
                                    : Icon(Icons.person, size: 40),
                            decoration: BoxDecoration(
                                color: Colors.white,
                                shape: BoxShape.circle,
                                boxShadow: [
                                  BoxShadow(
                                      blurRadius: 20.0,
                                      offset: Offset(2, 2),
                                      spreadRadius: 2,
                                      color: Colors.black12)
                                ]),
                            width: 85,
                            height: 85)),
                  ],
                ),
              ),
              Expanded(
                  child: Row(
                children: <Widget>[
                  Container(color: ThemeService.mainColor2, width: 10),
                  Expanded(
                      child: ListView(
                          //padding: EdgeInsets.only(right: 10),
                          controller:
                              _isMobile ? ScrollController() : _controller,
                          children: (InitService.menuItems ?? [])
                              .map<Widget>((c) => _selectedCategory == c.title
                                  ? _selectedMenuItemWidget(c)
                                  : _unselectedMenuItem(c))
                              .toList()
                            ..add(_beforeSelectedCategory != null &&
                                    _afterSelectedCategory == null
                                ? _unselectedMenuItem(null)
                                : Container()))),
                ],
              )),
              _isMobile
                  ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                      TextButton(
                          child: TecfyText(trans('Logout'),
                              style:
                                  TextStyle(color: ThemeService.secondryColor)),
                          onPressed: () => AccountService.signout(context)),
                      IconButton(
                          tooltip: trans('Lock'),
                          onPressed: () => AccountService.lock(context),
                          iconSize: 20,
                          icon: Icon(Icons.lock,
                              color: ThemeService.textOnMainColor)),
                    ])
                  : Container(),
              TecfyCoreApp.currentVersion.isEmpty
                  ? Container()
                  : Text(
                      'v${TecfyCoreApp.currentVersion}',
                      style: TextStyle(color: Colors.white54),
                    )
            ],
          )),
    );
  }

  _selectedMenuItemWidget(TecfyMenuItem c) {
    return Container(
      //margin: EdgeInsets.only(right: 10),
      color: ThemeService.mainColor2,
      // decoration: BoxDecoration(
      //   borderRadius: BorderRadius.only(
      //     bottomRight: Radius.circular(50),
      //     topRight: Radius.circular(50),
      //   ),
      //   color: selectedColur,
      // ),
      child: MaterialButton(
        hoverColor: Colors.transparent,
        splashColor: Colors.transparent,
        focusColor: Colors.transparent,
        highlightColor: Colors.transparent,
        animationDuration: Duration(milliseconds: 1),
        elevation: 0,
        focusElevation: 0,
        highlightElevation: 0,
        hoverElevation: 0,
        color: Colors.transparent,
        disabledColor: Colors.transparent,
        onPressed: () => _onItemClick(c),
        child: Padding(
          padding: EdgeInsets.only(bottom: 10),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.start,
            crossAxisAlignment: CrossAxisAlignment.stretch,
            children: (c.subMenuItems ?? [])
                .map<Widget>(
                  (sub) => Hero(
                    tag: sub.title == widget.selected
                        ? 'menuItem-selected'
                        : 'menuItem-${sub.title}',
                    child: MaterialButton(
                      hoverColor: Colors.transparent,
                      onPressed: () => _onItemClick(sub),
                      padding: EdgeInsets.only(
                          right: LocalConfigService.isArabic ? 60 : 0,
                          left: LocalConfigService.isArabic ? 0 : 60),
                      child: Align(
                        alignment: LocalConfigService.isArabic
                            ? Alignment.centerRight
                            : Alignment.centerLeft,
                        child: TecfyText(
                          trans(LocalConfigService.isArabic
                              ? sub.title
                              : sub.titleEn),
                          style: TextStyle(
                              fontWeight: sub.title == widget.selected
                                  ? FontWeight.w700
                                  : FontWeight.normal,
                              decoration: sub.title == widget.selected
                                  ? TextDecoration.underline
                                  : TextDecoration.none,
                              color: ThemeService.textOnMainColor),
                        ),
                      ),
                    ),
                  ),
                )
                .toList()
              ..insert(
                  0,
                  Padding(
                      padding: EdgeInsets.only(
                          top: 10,
                          bottom: (c.subMenuItems ?? []).length == 0 ? 10 : 0),
                      child: _selectedMenuItem(c))),
          ),
        ),
      ),
    );
  }

  _selectedMenuItem(TecfyMenuItem c) {
    return Row(
      children: <Widget>[
        SizedBox(width: 30),
        Container(
            decoration: BoxDecoration(
                color: ThemeService.secondryColor, shape: BoxShape.circle),
            width: 10,
            height: 10),
        SizedBox(width: 15),
        TecfyText(trans(LocalConfigService.isArabic ? c.title : c.titleEn),
            style: TextStyle(color: ThemeService.subColorLight, fontSize: 18))
      ],
    );
  }

  Widget _unselectedMenuItem(c) {
    if (c != null && _beforeSelectedCategory == c.title) {
      return Container(
          color: ThemeService.mainColor2,
          child: Container(
            child: _unselectedMenuItemButton(c),
            padding: EdgeInsets.only(bottom: 10),
            decoration: BoxDecoration(
              borderRadius: BorderRadius.only(
                  bottomRight:
                      isArabic ? Radius.circular(50) : Radius.circular(0),
                  bottomLeft:
                      isArabic ? Radius.circular(0) : Radius.circular(50)),
              color: ThemeService.mainColor,
            ),
          ));
    } else if (c == null || _afterSelectedCategory == c.title) {
      return Container(
          color: ThemeService.mainColor2,
          child: Container(
            child: c == null ? TecfyText('') : _unselectedMenuItemButton(c),
            decoration: BoxDecoration(
              borderRadius: BorderRadius.only(
                  topRight: isArabic ? Radius.circular(50) : Radius.circular(0),
                  topLeft: isArabic ? Radius.circular(0) : Radius.circular(50)),
              color: ThemeService.mainColor,
            ),
          ));
    } else {
      return Container(
          color: ThemeService.mainColor, child: _unselectedMenuItemButton(c));
    }
  }

  Widget _unselectedMenuItemButton(TecfyMenuItem c) {
    return MaterialButton(
        hoverColor: Colors.transparent,
        splashColor: Colors.transparent,
        focusColor: Colors.transparent,
        highlightColor: Colors.transparent,
        animationDuration: Duration(milliseconds: 1),
        elevation: 0,
        highlightElevation: 0,
        hoverElevation: 0,
        color: Colors.transparent,
        disabledColor: Colors.transparent,
        onPressed: () => _onItemClick(c),
        focusElevation: 0,
        child: Row(
          children: <Widget>[
            SizedBox(width: 30),
            Container(
                decoration: BoxDecoration(
                    color: ThemeService.inactiveMenuTextColor,
                    shape: BoxShape.circle),
                width: 10,
                height: 10),
            SizedBox(width: 15),
            Expanded(
                child: TecfyText(
                    trans(LocalConfigService.isArabic ? c.title : c.titleEn),
                    maxLines: 1,
                    style: TextStyle(
                        color: ThemeService.inactiveMenuTextColor,
                        fontSize: 18)))
          ],
        ));
  }
}
