part of tecfy_core_client_package;

class ChatContactsPage extends StatefulWidget {
  @override
  _ChatContactsPageState createState() => _ChatContactsPageState();
}

class _ChatContactsPageState extends State<ChatContactsPage> {
  List<User>? _users;

  @override
  void initState() {
    _loadUsers();
    super.initState();
  }

  _loadUsers() async {
    var result =
        await EntityService.getData(EntityService.getEntity('tecfyUser'));
    if (result.success) {
      _users = result.data?.map<User>((d) => User.fromJson(d)).toList();
      setState(() {});
    } else
      result.showMessage(context);
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(context, AppLocale.translate('Message Contacts'), 'chat',
        //appBar: MainAppBar(context:context,title:),
        isMobile: LayoutService.isMobile(context),
        child: _users == null
            ? Center(child: AppNavigator.getLoadingWidget(100))
            : ListView(
                children: _users
                        ?.map((user) => ListTile(
                              title: TecfyText(user.fullName),
                              onTap: () {
                                AppNavigator.navigateTo(
                                    context,
                                    () => ChatPage(User(
                                        id: user.id,
                                        recordNumber: 1,
                                        fullName: user.fullName)));
                              },
                            ))
                        .toList() ??
                    [],
              ));
  }
}
